Unit qsk3e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS12_p;

procedure qsk3e(var RINT :Array of Extended; A :Extended;
                B :Extended; F :Proc_F3E_A; N :Integer; EPS :Extended;
                K :Integer; var IND :Array of Integer;
                var R :Array of Extended; var IERR :Integer);

implementation

procedure qsk3e(var RINT :Array of Extended; A :Extended;
                B :Extended; F :Proc_F3E_A; N :Integer; EPS :Extended;
                K :Integer; var IND :Array of Integer;
                var R :Array of Extended; var IERR :Integer);
var
I,J,J1,J2,K1,K2 :Integer;
E,H,RH,S :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
IERR := 0;
for I:=1 to N do
 begin
  R[(I-1)+3*N] := 0.e0;
_1:
  IND[I-1] := 0;
 end;
K1 := 4*K;
if ( K  <= 0 ) 
 then K1 := 4;
H := (B-A)/K1;
F(A,RINT,IND);
F(B,R,IND);
for I:=1 to N do
 begin
  R[(I-1)+2*N] := (RINT[I-1]+R[(I-1)+0*N])*H;
  R[(I-1)+1*N] := R[(I-1)+2*N]*0.5e0;
_2:
  RINT[I-1] := R[(I-1)+2*N]*2.e0;
 end;
K1 := K1-1;
J1 := 1;
for J:=1 to K1 do
 begin
  F(A+J*H,R,IND);
  J1 := -1*J1;
  J2 := J div 4;
  for I:=1 to N do
   begin
    RH := R[(I-1)+0*N]*H;
    if ( J2*4  = J )
     then RINT[I-1] := RINT[I-1]+RH*4.e0;
    R[(I-1)+1*N] := R[(I-1)+1*N]+RH;
_3:
    R[(I-1)+2*N] := R[(I-1)+2*N]+RH*(1.e0+J1);
   end;
 end;
for I:=1 to N do
 begin
_4:
  RINT[I-1] := (RINT[I-1]-20.e0*R[(I-1)+2*N]+64.e0*R[(I-1)+1*N])/45.e0;
 end;
if ( EPS  <= 0.e0 ) 
 then goto _8;
K1 := K1+1;
_5:
H := H*0.5e0;
for J:=1 to K1 do
 begin
  F(A+(2.e0*J-1.e0)*H,R,IND);
  for I:=1 to N do
   begin
_6:
    R[(I-1)+3*N] := R[(I-1)+3*N]+R[(I-1)+0*N]*H;
   end;
 end;
K2 := 1;
for I:=1 to N do
 begin
  if ( IND[I-1]  > 0 )
   then goto _7;
  S := (64.e0*R[(I-1)+3*N]+12.e0*R[(I-1)+1*N]+R[(I-1)+2*N])/45.e0;
  E := Abs(RINT[I-1]-S)/(1.e0+Abs(S));
  RINT[I-1] := S;
  R[(I-1)+2*N] := R[(I-1)+1*N];
  R[(I-1)+1*N] := R[(I-1)+1*N]*0.5e0+R[(I-1)+3*N];
  R[(I-1)+3*N] := 0.e0;
  if ( E  <= EPS ) 
   then IND[I-1] := K1 div 4;
  if ( IND[I-1]  = 0 ) 
   then K2 := 0;
_7:
 end;
if ( K2  > 0 ) 
 then goto _8;
K1 := K1+K1;
if ( K1  <= 1048576 ) 
 then goto _5;
IERR := 65;
UTQS12(IERR,10);
_8:
end;

end.
